// VAʐMCu for RX621 by I.N.
//           rx621rslib.h
// mF{[hF Hdq RX621}CR{[h(12.0MHzNX^)
// JF Renesas CS+ for CC V8.06.00
// CPU: ICLK=98MHz, PCLK=48MHz, sizeof(int)=4(32bit)

//2021.10.15-17 ver.0.1 Jn(rxrslib.h𗬗p)
//2021.10.18    ver.0.2 M, 96MHz,48MHzݒ肠
//2021.10.19    ver.0.3 MCMmF
//2021.10.19    ver.0.4 SCI1,2,3,5,6ǉ
//2021.10.21    ver.1.0 

#ifndef RX621RSLIB_H
#define RX621RSLIB_H

#include "iodefine.h"
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

//\tgEFAfBC(P:us) [for RX621(96MHz)]
void delay_us(int n)
{
	for(int j=0; j<16*n; j++){
		;
	}
}

//\tgEFAfBC(P:ms) [for RX621(96MHz)]
void delay_ms(int n)
{
	delay_us(1000*n);
}

//`l̍ő(0,1,2,3,5,6)
#define RXRS_COMNUM 7

//obt@TCY2ȏォ2ׂ̂ݒ肷邱(ex.2,4,8,...)
//i[łf[^ʂ(obt@TCY-1)܂
//ftHg̑Mobt@TCY
#ifndef RXRS_RECVBUFFERSIZE0
	#define RXRS_RECVBUFFERSIZE0 32
#endif
#ifndef RXRS_SENDBUFFERSIZE0
	#define RXRS_SENDBUFFERSIZE0 32
#endif

#ifndef RXRS_RECVBUFFERSIZE1
	#define RXRS_RECVBUFFERSIZE1 32
#endif
#ifndef RXRS_SENDBUFFERSIZE1
	#define RXRS_SENDBUFFERSIZE1 32
#endif

#ifndef RXRS_RECVBUFFERSIZE2
	#define RXRS_RECVBUFFERSIZE2 32
#endif
#ifndef RXRS_SENDBUFFERSIZE2
	#define RXRS_SENDBUFFERSIZE2 32
#endif

#ifndef RXRS_RECVBUFFERSIZE3
	#define RXRS_RECVBUFFERSIZE3 32
#endif
#ifndef RXRS_SENDBUFFERSIZE3
	#define RXRS_SENDBUFFERSIZE3 32
#endif

#ifndef RXRS_RECVBUFFERSIZE5
	#define RXRS_RECVBUFFERSIZE5 32
#endif
#ifndef RXRS_SENDBUFFERSIZE5
	#define RXRS_SENDBUFFERSIZE5 32
#endif

#ifndef RXRS_RECVBUFFERSIZE6
	#define RXRS_RECVBUFFERSIZE6 32
#endif
#ifndef RXRS_SENDBUFFERSIZE6
	#define RXRS_SENDBUFFERSIZE6 32
#endif

// --- Mobt@ ---
unsigned char RXRS_rbuffer0[RXRS_RECVBUFFERSIZE0];
unsigned char RXRS_rbuffer1[RXRS_RECVBUFFERSIZE1];
unsigned char RXRS_rbuffer2[RXRS_RECVBUFFERSIZE2];
unsigned char RXRS_rbuffer3[RXRS_RECVBUFFERSIZE3];
unsigned char RXRS_rbuffer5[RXRS_RECVBUFFERSIZE5];
unsigned char RXRS_rbuffer6[RXRS_RECVBUFFERSIZE6];
volatile unsigned char *RXRS_rbuffer[RXRS_COMNUM]={RXRS_rbuffer0, RXRS_rbuffer1, RXRS_rbuffer2, RXRS_rbuffer3, NULL, RXRS_rbuffer5, RXRS_rbuffer6};
const int RXRS_rbuffersize [RXRS_COMNUM]={RXRS_RECVBUFFERSIZE0  , RXRS_RECVBUFFERSIZE1  , RXRS_RECVBUFFERSIZE2  , RXRS_RECVBUFFERSIZE3  , 0, RXRS_RECVBUFFERSIZE5  , RXRS_RECVBUFFERSIZE6  };
const int RXRS_rbufsizemask[RXRS_COMNUM]={RXRS_RECVBUFFERSIZE0-1, RXRS_RECVBUFFERSIZE1-1, RXRS_RECVBUFFERSIZE2-1, RXRS_RECVBUFFERSIZE3-1, 0, RXRS_RECVBUFFERSIZE5-1, RXRS_RECVBUFFERSIZE6-1};
// RXRS_recv_wptrn ͎ɏރf[^ʒuw
volatile int RXRS_recv_wptr[RXRS_COMNUM];
// RXRS_recv_rptrn==RXRS_recv_wptrn̂Ƃ̓f[^ȂCȊO͎ɓǂނׂf[^ʒuw
volatile int RXRS_recv_rptr[RXRS_COMNUM];

// --- Mobt@ ---
unsigned char RXRS_sbuffer0[RXRS_SENDBUFFERSIZE0];
unsigned char RXRS_sbuffer1[RXRS_SENDBUFFERSIZE1];
unsigned char RXRS_sbuffer2[RXRS_SENDBUFFERSIZE2];
unsigned char RXRS_sbuffer3[RXRS_SENDBUFFERSIZE3];
unsigned char RXRS_sbuffer5[RXRS_SENDBUFFERSIZE5];
unsigned char RXRS_sbuffer6[RXRS_SENDBUFFERSIZE6];
volatile unsigned char *RXRS_sbuffer[RXRS_COMNUM]={RXRS_sbuffer0, RXRS_sbuffer1, RXRS_sbuffer2, RXRS_sbuffer3, NULL, RXRS_sbuffer5, RXRS_sbuffer6};
const int RXRS_sbuffersize [RXRS_COMNUM]={RXRS_SENDBUFFERSIZE0  , RXRS_SENDBUFFERSIZE1  , RXRS_SENDBUFFERSIZE2  , RXRS_SENDBUFFERSIZE3  , 0, RXRS_SENDBUFFERSIZE5  , RXRS_SENDBUFFERSIZE6  };
const int RXRS_sbufsizemask[RXRS_COMNUM]={RXRS_SENDBUFFERSIZE0-1, RXRS_SENDBUFFERSIZE1-1, RXRS_SENDBUFFERSIZE2-1, RXRS_SENDBUFFERSIZE3-1, 0, RXRS_SENDBUFFERSIZE5-1, RXRS_SENDBUFFERSIZE6-1};
// RXRS_send_wptrn ͎ɏރf[^ʒuw
volatile int RXRS_send_wptr[RXRS_COMNUM];
// RXRS_send_rptrn==RXRS_send_wptrn̂Ƃ̓f[^ȂCȊO͎ɓǂނׂf[^ʒuw
volatile int RXRS_send_rptr[RXRS_COMNUM];

//M荞݂̏(0:ҋ@ 1:M 2:TEI荞݂ֈڍs)
volatile int rxrs_tx_status[RXRS_COMNUM];

// SCI0 ERI0 (xo)
#pragma interrupt (Excep_SCI0_ERI0(vect=214))
void Excep_SCI0_ERI0(void)
{
	volatile unsigned char c;
	if(SCI0.SSR.BIT.ORER){
		c= SCI0.RDR;			//I[o[G[
	}
	SCI0.SSR.BYTE &= ~0x38;		//G[tO(ORER,FER,PER)̃NA
}

// SCI0 RXI0
#pragma interrupt (Excep_SCI0_RXI0(vect=215))
void Excep_SCI0_RXI0(void)
{
	unsigned char c;
	c= SCI0.RDR;	//PoCgǂݍ

	if (RXRS_recv_wptr[0] == ((RXRS_recv_rptr[0]-1)&RXRS_rbufsizemask[0])) return;	//buffer full
	RXRS_rbuffer[0][RXRS_recv_wptr[0]]= c;
	RXRS_recv_wptr[0]= (RXRS_recv_wptr[0]+1)&RXRS_rbufsizemask[0];
}

// SCI0 TXI0
#pragma interrupt (Excep_SCI0_TXI0(vect=216))
void Excep_SCI0_TXI0(void)
{
	int rp= RXRS_send_rptr[0];

	SCI0.TDR= RXRS_sbuffer[0][rp];		//Mf[^Zbg
	//while(SCI0.SSR.BIT.TEND);			//M(TEND=0)mFĎ֐i
	
	rp= (rp+1)&RXRS_sbufsizemask[0];
	RXRS_send_rptr[0]= rp;

	if(rp==RXRS_send_wptr[0]){			//ŏIf[^̂Ƃ
		ICU.IER[0x1B].BIT.IEN0= 0;		//荞TXI0̋֎~
		rxrs_tx_status[0]= 2;
		SCI0.SCR.BIT.TEIE= 1;			//TEI݋
	}
}

// SCI0 TEI0 (xo)
#pragma interrupt (Excep_SCI0_TEI0(vect=217))
void Excep_SCI0_TEI0(void)
{
	SCI0.SCR.BIT.TEIE= 0;
	while(SCI0.SCR.BIT.TEIE);
	rxrs_tx_status[0]= 0;
}

// SCI1 ERI1
#pragma interrupt (Excep_SCI1_ERI1(vect=218))
void Excep_SCI1_ERI1(void)
{
	volatile unsigned char c;
	if(SCI1.SSR.BIT.ORER){
		c= SCI1.RDR;			//I[o[G[
	}
	SCI1.SSR.BYTE &= ~0x38;		//G[tO(ORER,FER,PER)̃NA
}

// SCI1 RXI1
#pragma interrupt (Excep_SCI1_RXI1(vect=219))
void Excep_SCI1_RXI1(void)
{
	unsigned char c;
	c= SCI1.RDR;	//PoCgǂݍ

	if (RXRS_recv_wptr[1] == ((RXRS_recv_rptr[1]-1)&RXRS_rbufsizemask[1])) return;	//buffer full
	RXRS_rbuffer[1][RXRS_recv_wptr[1]]= c;
	RXRS_recv_wptr[1]= (RXRS_recv_wptr[1]+1)&RXRS_rbufsizemask[1];
}

// SCI1 TXI1
#pragma interrupt (Excep_SCI1_TXI1(vect=220))
void Excep_SCI1_TXI1(void)
{
	int rp= RXRS_send_rptr[1];

	SCI1.TDR= RXRS_sbuffer[1][rp];		//Mf[^Zbg
	//while(SCI1.SSR.BIT.TEND);			//M(TEND=0)mFĎ֐i
	
	rp= (rp+1)&RXRS_sbufsizemask[1];
	RXRS_send_rptr[1]= rp;

	if(rp==RXRS_send_wptr[1]){			//ŏIf[^̂Ƃ
		ICU.IER[0x1B].BIT.IEN4= 0;		//荞TXI1̋֎~
		rxrs_tx_status[1]= 2;
		SCI1.SCR.BIT.TEIE= 1;			//TEI݋
	}
}

// SCI1 TEI1
#pragma interrupt (Excep_SCI1_TEI1(vect=221))
void Excep_SCI1_TEI1(void)
{
	SCI1.SCR.BIT.TEIE= 0;
	while(SCI1.SCR.BIT.TEIE);
	rxrs_tx_status[1]= 0;
}

// SCI2 ERI2
#pragma interrupt (Excep_SCI2_ERI2(vect=222))
void Excep_SCI2_ERI2(void)
{
	volatile unsigned char c;
	if(SCI2.SSR.BIT.ORER){
		c= SCI2.RDR;			//I[o[G[
	}
	SCI2.SSR.BYTE &= ~0x38;		//G[tO(ORER,FER,PER)̃NA
}

// SCI2 RXI2
#pragma interrupt (Excep_SCI2_RXI2(vect=223))
void Excep_SCI2_RXI2(void)
{
	unsigned char c;
	c= SCI2.RDR;	//PoCgǂݍ

	if (RXRS_recv_wptr[2] == ((RXRS_recv_rptr[2]-1)&RXRS_rbufsizemask[2])) return;	//buffer full
	RXRS_rbuffer[2][RXRS_recv_wptr[2]]= c;
	RXRS_recv_wptr[2]= (RXRS_recv_wptr[2]+1)&RXRS_rbufsizemask[2];
}

// SCI2 TXI2
#pragma interrupt (Excep_SCI2_TXI2(vect=224))
void Excep_SCI2_TXI2(void)
{
	int rp= RXRS_send_rptr[2];

	SCI2.TDR= RXRS_sbuffer[2][rp];		//Mf[^Zbg
	//while(SCI2.SSR.BIT.TEND);			//M(TEND=0)mFĎ֐i
	
	rp= (rp+1)&RXRS_sbufsizemask[2];
	RXRS_send_rptr[2]= rp;

	if(rp==RXRS_send_wptr[2]){			//ŏIf[^̂Ƃ
		ICU.IER[0x1C].BIT.IEN0= 0;		//荞TXI2̋֎~
		rxrs_tx_status[2]= 2;
		SCI2.SCR.BIT.TEIE= 1;			//TEI݋
	}
}

// SCI2 TEI2
#pragma interrupt (Excep_SCI2_TEI2(vect=225))
void Excep_SCI2_TEI2(void)
{
	SCI2.SCR.BIT.TEIE= 0;
	while(SCI2.SCR.BIT.TEIE);
	rxrs_tx_status[2]= 0;
}

// SCI3 ERI3
#pragma interrupt (Excep_SCI3_ERI3(vect=226))
void Excep_SCI3_ERI3(void)
{
	volatile unsigned char c;
	if(SCI3.SSR.BIT.ORER){
		c= SCI3.RDR;			//I[o[G[
	}
	SCI3.SSR.BYTE &= ~0x38;		//G[tO(ORER,FER,PER)̃NA
}

// SCI3 RXI3
#pragma interrupt (Excep_SCI3_RXI3(vect=227))
void Excep_SCI3_RXI3(void)
{
	unsigned char c;
	c= SCI3.RDR;	//PoCgǂݍ

	if (RXRS_recv_wptr[3] == ((RXRS_recv_rptr[3]-1)&RXRS_rbufsizemask[3])) return;	//buffer full
	RXRS_rbuffer[3][RXRS_recv_wptr[3]]= c;
	RXRS_recv_wptr[3]= (RXRS_recv_wptr[3]+1)&RXRS_rbufsizemask[3];
}

// SCI3 TXI3
#pragma interrupt (Excep_SCI3_TXI3(vect=228))
void Excep_SCI3_TXI3(void)
{
	int rp= RXRS_send_rptr[3];

	SCI3.TDR= RXRS_sbuffer[3][rp];		//Mf[^Zbg
	//while(SCI3.SSR.BIT.TEND);			//M(TEND=0)mFĎ֐i
	
	rp= (rp+1)&RXRS_sbufsizemask[3];
	RXRS_send_rptr[3]= rp;

	if(rp==RXRS_send_wptr[3]){			//ŏIf[^̂Ƃ
		ICU.IER[0x1C].BIT.IEN4= 0;		//荞TXI3̋֎~
		rxrs_tx_status[3]= 2;
		SCI3.SCR.BIT.TEIE= 1;			//TEI݋
	}
}

// SCI3 TEI3
#pragma interrupt (Excep_SCI3_TEI3(vect=229))
void Excep_SCI3_TEI3(void)
{
	SCI3.SCR.BIT.TEIE= 0;
	while(SCI3.SCR.BIT.TEIE);
	rxrs_tx_status[3]= 0;
}

// SCI5 ERI5
#pragma interrupt (Excep_SCI5_ERI5(vect=234))
void Excep_SCI5_ERI5(void)
{
	volatile unsigned char c;
	if(SCI5.SSR.BIT.ORER){
		c= SCI5.RDR;			//I[o[G[
	}
	SCI5.SSR.BYTE &= ~0x38;		//G[tO(ORER,FER,PER)̃NA
}

// SCI5 RXI5
#pragma interrupt (Excep_SCI5_RXI5(vect=235))
void Excep_SCI5_RXI5(void)
{
	unsigned char c;
	c= SCI5.RDR;	//PoCgǂݍ

	if (RXRS_recv_wptr[5] == ((RXRS_recv_rptr[5]-1)&RXRS_rbufsizemask[5])) return;	//buffer full
	RXRS_rbuffer[5][RXRS_recv_wptr[5]]= c;
	RXRS_recv_wptr[5]= (RXRS_recv_wptr[5]+1)&RXRS_rbufsizemask[5];
}

// SCI5 TXI5
#pragma interrupt (Excep_SCI5_TXI5(vect=236))
void Excep_SCI5_TXI5(void)
{
	int rp= RXRS_send_rptr[5];

	SCI5.TDR= RXRS_sbuffer[5][rp];		//Mf[^Zbg
	//while(SCI5.SSR.BIT.TEND);			//M(TEND=0)mFĎ֐i
	
	rp= (rp+1)&RXRS_sbufsizemask[5];
	RXRS_send_rptr[5]= rp;

	if(rp==RXRS_send_wptr[5]){			//ŏIf[^̂Ƃ
		ICU.IER[0x1D].BIT.IEN4= 0;		//荞TXI5̋֎~
		rxrs_tx_status[5]= 2;
		SCI5.SCR.BIT.TEIE= 1;			//TEI݋
	}
}

// SCI5 TEI5
#pragma interrupt (Excep_SCI5_TEI5(vect=237))
void Excep_SCI5_TEI5(void)
{
	SCI5.SCR.BIT.TEIE= 0;
	while(SCI5.SCR.BIT.TEIE);
	rxrs_tx_status[5]= 0;
}

// SCI6 ERI6
#pragma interrupt (Excep_SCI6_ERI6(vect=238))
void Excep_SCI6_ERI6(void)
{
	volatile unsigned char c;
	if(SCI6.SSR.BIT.ORER){
		c= SCI6.RDR;			//I[o[G[
	}
	SCI6.SSR.BYTE &= ~0x38;		//G[tO(ORER,FER,PER)̃NA
}

// SCI6 RXI6
#pragma interrupt (Excep_SCI6_RXI6(vect=239))
void Excep_SCI6_RXI6(void)
{
	unsigned char c;
	c= SCI6.RDR;	//PoCgǂݍ

	if (RXRS_recv_wptr[6] == ((RXRS_recv_rptr[6]-1)&RXRS_rbufsizemask[6])) return;	//buffer full
	RXRS_rbuffer[6][RXRS_recv_wptr[6]]= c;
	RXRS_recv_wptr[6]= (RXRS_recv_wptr[6]+1)&RXRS_rbufsizemask[6];
}

// SCI6 TXI6
#pragma interrupt (Excep_SCI6_TXI6(vect=240))
void Excep_SCI6_TXI6(void)
{
	int rp= RXRS_send_rptr[6];

	SCI6.TDR= RXRS_sbuffer[6][rp];		//Mf[^Zbg
	//while(SCI6.SSR.BIT.TEND);			//M(TEND=0)mFĎ֐i
	
	rp= (rp+1)&RXRS_sbufsizemask[6];
	RXRS_send_rptr[6]= rp;

	if(rp==RXRS_send_wptr[6]){			//ŏIf[^̂Ƃ
		ICU.IER[0x1E].BIT.IEN0= 0;		//荞TXI6̋֎~
		rxrs_tx_status[6]= 2;
		SCI6.SCR.BIT.TEIE= 1;			//TEI݋
	}
}

// SCI6 TEI6
#pragma interrupt (Excep_SCI6_TEI6(vect=241))
void Excep_SCI6_TEI6(void)
{
	SCI6.SCR.BIT.TEIE= 0;
	while(SCI6.SCR.BIT.TEIE);
	rxrs_tx_status[6]= 0;
}

//--------------------------------------------------------------------------------
// |[g̃I[v RXRS_Open()
//--------------------------------------------------------------------------------
// ncom : `lԍ(0,1,2,3,5,6)
// brr  : {[[gw  vZ 48M/(16*(brr+1)) [bps]
//  brrlƃ{[[g
//          0 ->3000000.0 [bps]
//          1 ->1500000.0 [bps]
//          2 ->1000000.0 [bps]
//          3 -> 750000.0 [bps]
//          4 -> 600000.0 [bps]
//          5 -> 500000.0 [bps]
//          6 -> 428571.4 [bps]
//          7 -> 375000.0 [bps]
//          8 -> 333333.3 [bps]
//          9 -> 300000.0 [bps]
//         10 -> 272727.3 [bps]
//         11 -> 250000.0 [bps]
//         12 -> 230769.2 [bps]
//         25 -> 115384.6 [bps]
//         51 ->  57692.3 [bps]
//         77 ->  38461.5 [bps]
//        155 ->  19230.8 [bps]
//--------------------------------------------------------------------------------
// IvVFrx621rslib.h̃CN[hOɈȉ`ƒʐMdlύXł
//           (`lx:[0,1,2,3,5,6])
//   ȗ́CpeBȂCXgbvrbgPCf[^W
//   #define SCIx_PARITY_ODD
//   #define SCIx_PARITY_EVEN
//   #define SCIx_STOP_2
//   #define SCIx_DATA_7
//   Mobt@TCY(ftHg:32)(n:TCY[oCg])
//   #define RXRS_RECVBUFFERSIZEx n 
//   Mobt@TCY(ftHg:32)(n:TCY[oCg])
//   #define RXRS_SENDBUFFERSIZEx n
//--------------------------------------------------------------------------------
// gp|[g̃ftHg
// SCI0:  |[gP21 =RXD, P20 =TXD
// SCI1:  |[gP30 =RXD, P26 =TXD
// SCI2:  |[gP12 =RXD, P13 =TXD
// SCI3:  |[gP25 =RXD, P23 =TXD
// SCI5:  |[gPC2 =RXD, PC3 =TXD
// SCI6:  |[gP33 =RXD, P32 =TXD
//
// SCI2:  |[gP52 =RXD, P50 =TXDgɂ͎sCN[hOɒ`
//   #define SCI2_RXDTXD_P52P50
//--------------------------------------------------------------------------------
int RXRS_Open(int ncom, int brr)
{
	//NbNg̕ύX
	SYSTEM.SCKCR.BIT.ICK= 0;	//VXeNbN 12MHz x8
	while(SYSTEM.SCKCR.BIT.ICK != 0);
	SYSTEM.SCKCR.BIT.PCK= 1;	//ӃW[NbN 12MHz x4
	while(SYSTEM.SCKCR.BIT.PCK != 1);

	//Mobt@̃|C^
	RXRS_recv_wptr[ncom]= 0;
	RXRS_recv_rptr[ncom]= 0;
	RXRS_send_wptr[ncom]= 0;
	RXRS_send_rptr[ncom]= 0;

	rxrs_tx_status[ncom]= 0;
	
	switch(ncom){
		// ----- SCI0 -----
		case 0:
			SYSTEM.MSTPCRB.BIT.MSTPB31= 0;	//SCI0W[~̉
			SCI0.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			PORT2.ICR.BIT.B1= 1;			//P21:̓obt@L

			SCI0.SCR.BIT.CKE= 0;			//{[[gWFl[^iSCKo͂Ȃj
			SCI0.SMR.BYTE= 0;				//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI0_PARITY_EVEN
					SCI0.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI0_PARITY_ODD
					SCI0.SMR.BIT.PE= 1;		//peBL
					SCI0.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI0_STOP_2
					SCI0.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI0_DATA_7
					SCI0.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI0.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI0.SEMR.BIT.ABCS= 1;	//ABCS=1  vZ: 48M/(16*(brr+1)) [bps]
									//ABCS=0ȂvZ: 48M/(32*(brr+1)) [bps]

			SCI0.BRR= brr;			//{[[g(BRR)w
			
			//1bitԈȏ̃EFCgKv
			delay_us(105);			//105us: 9600[bps]1bit

			ICU.IPR[0x80].BIT.IPR= 5;		//荞ݗD惌x(15:ō)
			ICU.IER[0x1A].BIT.IEN6= 1;		//荞ERI0
			ICU.IER[0x1A].BIT.IEN7= 1;		//荞RXI0
			ICU.IER[0x1B].BIT.IEN0= 0;		//荞TXI0(ł͋Ȃ)
			ICU.IER[0x1B].BIT.IEN1= 1;		//荞TEI0

			SCI0.SCR.BIT.TIE= 1;		//TXI݋
			SCI0.SCR.BIT.RIE= 1;		//RXI݋
			SCI0.SCR.BIT.TEIE= 0;		//TEI݋(ł͋Ȃ)
			SCI0.SCR.BYTE |= 0x30;		//TE=1,RE=1(ɁDdv)
			break;
		// ----- SCI1 -----
		case 1:
			SYSTEM.MSTPCRB.BIT.MSTPB30= 0;	//SCI1W[~̉
			SCI1.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			PORT3.ICR.BIT.B0= 1;			//P30:̓obt@L

			SCI1.SCR.BIT.CKE= 0;			//{[[gWFl[^iSCKo͂Ȃj
			SCI1.SMR.BYTE= 0;				//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI1_PARITY_EVEN
					SCI1.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI1_PARITY_ODD
					SCI1.SMR.BIT.PE= 1;		//peBL
					SCI1.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI1_STOP_2
					SCI1.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI1_DATA_7
					SCI1.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI1.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI1.SEMR.BIT.ABCS= 1;	//ABCS=1  vZ: 48M/(16*(brr+1)) [bps]
									//ABCS=0ȂvZ: 48M/(32*(brr+1)) [bps]

			SCI1.BRR= brr;			//{[[g(BRR)w
			
			//1bitԈȏ̃EFCgKv
			delay_us(105);			//105us: 9600[bps]1bit

			ICU.IPR[0x81].BIT.IPR= 5;		//荞ݗD惌x(15:ō)
			ICU.IER[0x1B].BIT.IEN2= 1;		//荞ERI1
			ICU.IER[0x1B].BIT.IEN3= 1;		//荞RXI1
			ICU.IER[0x1B].BIT.IEN4= 0;		//荞TXI1(ł͋Ȃ)
			ICU.IER[0x1B].BIT.IEN5= 1;		//荞TEI1

			SCI1.SCR.BIT.TIE= 1;		//TXI݋
			SCI1.SCR.BIT.RIE= 1;		//RXI݋
			SCI1.SCR.BIT.TEIE= 0;		//TEI݋(ł͋Ȃ)
			SCI1.SCR.BYTE |= 0x30;		//TE=1,RE=1(ɁDdv)
			break;
		// ----- SCI2 -----
		case 2:
			SYSTEM.MSTPCRB.BIT.MSTPB29= 0;	//SCI2W[~̉
			SCI2.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)

		#ifdef SCI2_RXDTXD_P52P50
			IOPORT.PFFSCI.BIT.SCI2S= 1;		//P52,P50RXD,TXD
			PORT5.ICR.BIT.B2= 1;			//P52:̓obt@L
		#else
			IOPORT.PFFSCI.BIT.SCI2S= 0;		//P12,P13RXD,TXD
			PORT1.ICR.BIT.B2= 1;			//P12:̓obt@L
		#endif
			
			SCI2.SCR.BIT.CKE= 0;			//{[[gWFl[^iSCKo͂Ȃj
			SCI2.SMR.BYTE= 0;				//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI2_PARITY_EVEN
					SCI2.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI2_PARITY_ODD
					SCI2.SMR.BIT.PE= 1;		//peBL
					SCI2.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI2_STOP_2
					SCI2.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI2_DATA_7
					SCI2.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI2.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI2.SEMR.BIT.ABCS= 1;	//ABCS=1  vZ: 48M/(16*(brr+1)) [bps]
									//ABCS=0ȂvZ: 48M/(32*(brr+1)) [bps]

			SCI2.BRR= brr;			//{[[g(BRR)w
			
			//1bitԈȏ̃EFCgKv
			delay_us(105);			//105us: 9600[bps]1bit

			ICU.IPR[0x82].BIT.IPR= 5;		//荞ݗD惌x(15:ō)
			ICU.IER[0x1B].BIT.IEN6= 1;		//荞ERI2
			ICU.IER[0x1B].BIT.IEN7= 1;		//荞RXI2
			ICU.IER[0x1C].BIT.IEN0= 0;		//荞TXI2(ł͋Ȃ)
			ICU.IER[0x1C].BIT.IEN1= 1;		//荞TEI2

			SCI2.SCR.BIT.TIE= 1;		//TXI݋
			SCI2.SCR.BIT.RIE= 1;		//RXI݋
			SCI2.SCR.BIT.TEIE= 0;		//TEI݋(ł͋Ȃ)
			SCI2.SCR.BYTE |= 0x30;		//TE=1,RE=1(ɁDdv)
			break;
		// ----- SCI3 -----
		case 3:
			SYSTEM.MSTPCRB.BIT.MSTPB28= 0;	//SCI3W[~̉
			SCI3.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			PORT2.ICR.BIT.B5= 1;			//P25:̓obt@L

			SCI3.SCR.BIT.CKE= 0;			//{[[gWFl[^iSCKo͂Ȃj
			SCI3.SMR.BYTE= 0;				//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI3_PARITY_EVEN
					SCI3.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI3_PARITY_ODD
					SCI3.SMR.BIT.PE= 1;		//peBL
					SCI3.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI3_STOP_2
					SCI3.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI3_DATA_7
					SCI3.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI3.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI3.SEMR.BIT.ABCS= 1;	//ABCS=1  vZ: 48M/(16*(brr+1)) [bps]
									//ABCS=0ȂvZ: 48M/(32*(brr+1)) [bps]

			SCI3.BRR= brr;			//{[[g(BRR)w
			
			//1bitԈȏ̃EFCgKv
			delay_us(105);			//105us: 9600[bps]1bit

			ICU.IPR[0x83].BIT.IPR= 5;		//荞ݗD惌x(15:ō)
			ICU.IER[0x1C].BIT.IEN2= 1;		//荞ERI3
			ICU.IER[0x1C].BIT.IEN3= 1;		//荞RXI3
			ICU.IER[0x1C].BIT.IEN4= 0;		//荞TXI3(ł͋Ȃ)
			ICU.IER[0x1C].BIT.IEN5= 1;		//荞TEI3

			SCI3.SCR.BIT.TIE= 1;		//TXI݋
			SCI3.SCR.BIT.RIE= 1;		//RXI݋
			SCI3.SCR.BIT.TEIE= 0;		//TEI݋(ł͋Ȃ)
			SCI3.SCR.BYTE |= 0x30;		//TE=1,RE=1(ɁDdv)
			break;
		// ----- SCI5 -----
		case 5:
			SYSTEM.MSTPCRB.BIT.MSTPB26= 0;	//SCI5W[~̉
			SCI5.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			PORTC.ICR.BIT.B2= 1;			//PC2:̓obt@L

			SCI5.SCR.BIT.CKE= 0;			//{[[gWFl[^iSCKo͂Ȃj
			SCI5.SMR.BYTE= 0;				//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI5_PARITY_EVEN
					SCI5.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI5_PARITY_ODD
					SCI5.SMR.BIT.PE= 1;		//peBL
					SCI5.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI5_STOP_2
					SCI5.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI5_DATA_7
					SCI5.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI5.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI5.SEMR.BIT.ABCS= 1;	//ABCS=1  vZ: 48M/(16*(brr+1)) [bps]
									//ABCS=0ȂvZ: 48M/(32*(brr+1)) [bps]

			SCI5.BRR= brr;			//{[[g(BRR)w
			
			//1bitԈȏ̃EFCgKv
			delay_us(105);			//105us: 9600[bps]1bit

			ICU.IPR[0x85].BIT.IPR= 5;		//荞ݗD惌x(15:ō)
			ICU.IER[0x1D].BIT.IEN2= 1;		//荞ERI5
			ICU.IER[0x1D].BIT.IEN3= 1;		//荞RXI5
			ICU.IER[0x1D].BIT.IEN4= 0;		//荞TXI5(ł͋Ȃ)
			ICU.IER[0x1D].BIT.IEN5= 1;		//荞TEI5

			SCI5.SCR.BIT.TIE= 1;		//TXI݋
			SCI5.SCR.BIT.RIE= 1;		//RXI݋
			SCI5.SCR.BIT.TEIE= 0;		//TEI݋(ł͋Ȃ)
			SCI5.SCR.BYTE |= 0x30;		//TE=1,RE=1(ɁDdv)
			break;
		// ----- SCI6 -----
		case 6:
			SYSTEM.MSTPCRB.BIT.MSTPB25= 0;	//SCI6W[~̉
			SCI6.SCR.BYTE= 0x00;			//TIE,RIE,TE,RE,TEIE0 (SCR)
			
			PORT3.ICR.BIT.B3= 1;			//P33:̓obt@L

			SCI6.SCR.BIT.CKE= 0;			//{[[gWFl[^iSCKo͂Ȃj
			SCI6.SMR.BYTE= 0;				//PCLK(48MHz),1STOP,PARITY:NONE,8BIT-DATA,
				#ifdef SCI6_PARITY_EVEN
					SCI6.SMR.BIT.PE= 1;		//peBL(peB)
				#endif
				#ifdef SCI6_PARITY_ODD
					SCI6.SMR.BIT.PE= 1;		//peBL
					SCI6.SMR.BIT.PM= 1;		//peB
				#endif
				#ifdef SCI6_STOP_2
					SCI6.SMR.BIT.STOP= 1;	//XgbvrbgQ
				#endif
				#ifdef SCI6_DATA_7
					SCI6.SMR.BIT.CHR= 1;	//f[^Vrbg
				#endif
			SCI6.SCMR.BYTE= 0xf2;	//VAR~jP[VC^tF[X[h
			SCI6.SEMR.BIT.ABCS= 1;	//ABCS=1  vZ: 48M/(16*(brr+1)) [bps]
									//ABCS=0ȂvZ: 48M/(32*(brr+1)) [bps]

			SCI6.BRR= brr;			//{[[g(BRR)w
			
			//1bitԈȏ̃EFCgKv
			delay_us(105);			//105us: 9600[bps]1bit

			ICU.IPR[0x86].BIT.IPR= 5;		//荞ݗD惌x(15:ō)
			ICU.IER[0x1D].BIT.IEN6= 1;		//荞ERI6
			ICU.IER[0x1D].BIT.IEN7= 1;		//荞RXI6
			ICU.IER[0x1E].BIT.IEN0= 0;		//荞TXI6(ł͋Ȃ)
			ICU.IER[0x1E].BIT.IEN1= 1;		//荞TEI6

			SCI6.SCR.BIT.TIE= 1;		//TXI݋
			SCI6.SCR.BIT.RIE= 1;		//RXI݋
			SCI6.SCR.BIT.TEIE= 0;		//TEI݋(ł͋Ȃ)
			SCI6.SCR.BYTE |= 0x30;		//TE=1,RE=1(ɁDdv)
			break;
	}

	return 0;
}

// Mobt@̃`FbN
// obt@̋󂫂oCgPʂŕԂ
// (Mobt@̃TCY傫ȒlԂƂ͂Ȃ)
int RXRS_CheckSend(int ncom)
{
	int rp,wp;
	wp= RXRS_send_wptr[ncom];
	rp= RXRS_send_rptr[ncom];

	if (wp>=rp){
		return RXRS_sbuffersize[ncom]-(wp-rp)-1;
	}else{
		return rp-wp-1;
	}
}

// Mobt@̃NA
// Sf[^̑M҂Ăobt@NA
void RXRS_ClearSend(int ncom)
{
	while(rxrs_tx_status[ncom]);	//Sf[^M҂

	RXRS_send_wptr[ncom]= RXRS_send_rptr[ncom];
}

// f[^̑M (f[^͑Mobt@֊i[)
// Mobt@tɂȂ΁Cȍ~̃f[^͔jD
// Of[^M̂ƂCŏIoCgMłȂ΁C̃f[^Mobt@ɒǉC͂߂D
// Of[^̍ŏIoCgḾC̃oCg܂ő҂Ă琧䂪߂D
// ߂lFMobt@փZbgłf[^iPʁFoCgj
int RXRS_Send(int ncom, const void *buf, int n)
{
	int i,wp,rp;
	char *pbuf= (char *)buf;
	
	//f[^𑗐Mobt@֊i[
	for(i=0; i<n; i++){
		wp= RXRS_send_wptr[ncom];
		rp= RXRS_send_rptr[ncom];
		if (wp == ((rp-1)&RXRS_sbufsizemask[ncom])) break;	//buffer full
		RXRS_sbuffer[ncom][wp]= *pbuf++;
		RXRS_send_wptr[ncom]= (wp+1)&RXRS_sbufsizemask[ncom];
	}

	//TEI荞ݏ(O̍ŏIoCgM)̂Ƃ͂ꂪI܂ő҂
	while(rxrs_tx_status[ncom]==2);

	if(!rxrs_tx_status[ncom]){
		rxrs_tx_status[ncom]= 1;
		//ŏTXǏĂяo
		switch(ncom){
			case 0:
				SCI0.SSR.BYTE &= ~0x38;		//MG[tO(ORER,FER,PER)̃NA
				ICU.IER[0x1B].BIT.IEN0= 1;	//荞TXI0iōŏTXI荞݂j
				break;
			case 1:
				SCI1.SSR.BYTE &= ~0x38;		//MG[tO(ORER,FER,PER)̃NA
				ICU.IER[0x1B].BIT.IEN4= 1;	//荞TXI1iōŏTXI荞݂j
				break;
			case 2:
				SCI2.SSR.BYTE &= ~0x38;		//MG[tO(ORER,FER,PER)̃NA
				ICU.IER[0x1C].BIT.IEN0= 1;	//荞TXI2iōŏTXI荞݂j
				break;
			case 3:
				SCI3.SSR.BYTE &= ~0x38;		//MG[tO(ORER,FER,PER)̃NA
				ICU.IER[0x1C].BIT.IEN4= 1;	//荞TXI3iōŏTXI荞݂j
				break;
			case 5:
				SCI5.SSR.BYTE &= ~0x38;		//MG[tO(ORER,FER,PER)̃NA
				ICU.IER[0x1D].BIT.IEN4= 1;	//荞TXI5iōŏTXI荞݂j
				break;
			case 6:
				SCI6.SSR.BYTE &= ~0x38;		//MG[tO(ORER,FER,PER)̃NA
				ICU.IER[0x1E].BIT.IEN0= 1;	//荞TXI6iōŏTXI荞݂j
				break;
		}
	}

	return i;
}

// P̑M
// ߂lFMoCg
int RXRS_Putc(int ncom, char c)
{
	return RXRS_Send(ncom,&c,1);
}

// ̑MiŌ\r\nj
// ߂lFMoCg
int RXRS_Puts(int ncom, const char *s)
{
	int n;

	n= strlen(s);
	n= RXRS_Send(ncom,s,n);
	n+=RXRS_Send(ncom,"\r\n",2);

	return n;
}

// ̑MiŌɉȂj
// ߂lFMoCg
int RXRS_Sends(int ncom, const char *s)
{
	int n;

	n= strlen(s);
	n= RXRS_Send(ncom,s,n);

	return n;
}

// t񑗐M
// ߂lFMoCg
#include <stdio.h>
#include <stdarg.h>
#ifndef RXRS_PRINTF_BUFFERSIZE
	#define RXRS_PRINTF_BUFFERSIZE	256
#endif
int RXRS_Printf(int ncom, const char *format, ...)
{
	va_list vl;
	char buf[RXRS_PRINTF_BUFFERSIZE];

	va_start(vl,format);
	vsprintf(buf,format,vl);

	return RXRS_Sends(ncom,buf);
}

// f[^̎M (Mobt@̓ǂݏo)
// ߂lFMoCg
int RXRS_Recv(int ncom, void *buf, int n)
{
	int i,rp,wp;
	char *pbuf= (char *)buf;
	
	for(i=0; i<n; i++){
		rp= RXRS_recv_rptr[ncom];
		wp= RXRS_recv_wptr[ncom];
		if(rp==wp) break;
		*pbuf++ = RXRS_rbuffer[ncom][rp];
		RXRS_recv_rptr[ncom]= (rp+1)&RXRS_rbufsizemask[ncom];
	}
	return i;
}

// Mobt@̃`FbN
// (obt@Ɋi[ς݂̃f[^oCgPʂŕԂ)
int RXRS_CheckRecv(int ncom)
{
	int rp,wp;
	rp= RXRS_recv_rptr[ncom];
	wp= RXRS_recv_wptr[ncom];

	if (wp>=rp){
		return wp-rp;
	}else{
		return RXRS_rbuffersize[ncom]-(rp-wp);
	}
}

// Mobt@̃NA
void RXRS_ClearRecv(int ncom)
{
	RXRS_recv_rptr[ncom]= RXRS_recv_wptr[ncom];
}

// P̎M
int RXRS_Getc(int ncom)
{
	char c;
	if (!RXRS_Recv(ncom,&c,1)) return -1;
	return c;
}

// (Ōオ\n,\r,0̂ꂩ)̎M
int RXRS_Gets(int ncom, char *s)
{
	int n=0;

	for(;;){
		if (RXRS_Recv(ncom,s,1)==1) {
			if(*s=='\n' || *s=='\r' || *s==0){
				*s=0;
				n++;
				break;
			}else{
				s++;
				n++;
			}
		}
	}
	return n;
}

#ifdef __cplusplus
}
#endif

#endif
